<?php

	require_once(TOOLKIT . '/class.entrymanager.php');
	require_once(TOOLKIT . '/class.sectionmanager.php');

	Class extension_edit_section_handle extends Extension{

		public function __construct($args) {
			$this->_Parent =& $args['parent'];
		}

		public function about(){
			return array(
				'name' => 'Edit Section Handle',
				'version' => '1.0.0',
				'release-date' => '2011-11-3',
				'author' => array(
					array(
						'name' => 'm-r Tarakanoff',
						'website' => 'http://jnet.kz/my/tarakanoff/'
					)
				)
			);
		}
	
		public function getSubscribedDelegates(){
			return array(
				array(
					'page' => '/blueprints/sections/',
					'delegate' => 'AddSectionElements',
					'callback' => 'addSectionSettings'
				),
				array(
					'page'		=> '/blueprints/sections/',
					'delegate'	=> 'SectionPreCreate',
					'callback'	=> 'saveSectionSettings'
				),
				array(
					'page'		=> '/blueprints/sections/',
					'delegate'	=> 'SectionPreEdit',
					'callback'	=> 'saveSectionSettings'
				)
			);
		}

		
	/*-------------------------------------------------------------------------
		Delegates
	-------------------------------------------------------------------------*/

		public function addSectionSettings($context) {

			$label = Widget::Label(__('Handle'));
			$label->appendChild(Widget::Input('meta[name]', General::sanitize($meta['name'])));
		
			$setting = array('value' => $context['meta']['handle']);
		
			$label = new XMLElement('label', __('Handle'));
			$label->appendChild(new XMLElement('input', '', array_merge($setting, array('name' => 'meta[handle]', 'type' => 'text'))));

			// Find context
			$fieldset = $context['form']->getChildren();
			$group = $fieldset[0]->getChildren();
			$column = $group[1]->getChildren();

			$column[0]->insertChildAt(1, $label);
		}
		
		public function saveSectionSettings($context) {

			$section_id = $context['section_id'];
			$handle = $_POST['meta']['handle'];
			
			if(!empty($handle)) {
				if($this->checkHandleForDuplicate($section_id, $handle)) {
					$context['meta']['handle'] = $handle;
				}
				else {
					return;
				}
			}
		}
		
	/*-------------------------------------------------------------------------
		Helpers
	-------------------------------------------------------------------------*/

		private function checkHandleForDuplicate($section_id, $section_handle)
		{
			if(Symphony::Database()->fetchRow(0, "SELECT * FROM `tbl_sections` WHERE `handle` = '" . $section_handle . "' AND `id` != {$section_id} LIMIT 1")) {
				return false;
			}
			
			return true;
		}
	}
